// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from microstrain_inertial_msgs:msg/MipGpsTimestamp.idl
// generated code does not contain a copyright notice

#include "microstrain_inertial_msgs/msg/detail/mip_gps_timestamp__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
const rosidl_type_hash_t *
microstrain_inertial_msgs__msg__MipGpsTimestamp__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x3d, 0x18, 0xbd, 0xc9, 0xdd, 0xab, 0x82, 0xcc,
      0x84, 0x34, 0xfe, 0xbc, 0xf1, 0x77, 0xe6, 0xbc,
      0x99, 0x9c, 0xd1, 0x1c, 0xe5, 0x8a, 0x0e, 0x6b,
      0x5b, 0x64, 0x39, 0x05, 0xef, 0xbb, 0x5c, 0x1f,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "microstrain_inertial_msgs/msg/detail/mip_gps_timestamp_valid_flags__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t microstrain_inertial_msgs__msg__MipGpsTimestampValidFlags__EXPECTED_HASH = {1, {
    0x4b, 0x1a, 0x94, 0xf3, 0x6a, 0x0f, 0xdd, 0xbf,
    0x8a, 0x4f, 0xdb, 0xab, 0x5f, 0xa5, 0xa9, 0x30,
    0x43, 0x5e, 0x8a, 0xd7, 0x63, 0xa6, 0x17, 0xc4,
    0x63, 0x50, 0x2c, 0x4e, 0x4d, 0xe5, 0xef, 0xa8,
  }};
#endif

static char microstrain_inertial_msgs__msg__MipGpsTimestamp__TYPE_NAME[] = "microstrain_inertial_msgs/msg/MipGpsTimestamp";
static char microstrain_inertial_msgs__msg__MipGpsTimestampValidFlags__TYPE_NAME[] = "microstrain_inertial_msgs/msg/MipGpsTimestampValidFlags";

// Define type names, field names, and default values
static char microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__tow[] = "tow";
static char microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__week_number[] = "week_number";
static char microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__valid_flags[] = "valid_flags";

static rosidl_runtime_c__type_description__Field microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELDS[] = {
  {
    {microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__tow, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__week_number, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__valid_flags, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {microstrain_inertial_msgs__msg__MipGpsTimestampValidFlags__TYPE_NAME, 55, 55},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription microstrain_inertial_msgs__msg__MipGpsTimestamp__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {microstrain_inertial_msgs__msg__MipGpsTimestampValidFlags__TYPE_NAME, 55, 55},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
microstrain_inertial_msgs__msg__MipGpsTimestamp__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {microstrain_inertial_msgs__msg__MipGpsTimestamp__TYPE_NAME, 45, 45},
      {microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELDS, 3, 3},
    },
    {microstrain_inertial_msgs__msg__MipGpsTimestamp__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&microstrain_inertial_msgs__msg__MipGpsTimestampValidFlags__EXPECTED_HASH, microstrain_inertial_msgs__msg__MipGpsTimestampValidFlags__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = microstrain_inertial_msgs__msg__MipGpsTimestampValidFlags__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Definition of a GPS timestamp.\n"
  "# For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm\n"
  "#   Note: This message will never be published on it's own, only included in other messages\n"
  "\n"
  "# GPS time of week (seconds)\n"
  "float64 tow\n"
  "\n"
  "# GPS Week number since 1980 (weeks)\n"
  "uint16 week_number\n"
  "\n"
  "# Valid Flags bitfield\n"
  "microstrain_inertial_msgs/MipGpsTimestampValidFlags valid_flags";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
microstrain_inertial_msgs__msg__MipGpsTimestamp__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {microstrain_inertial_msgs__msg__MipGpsTimestamp__TYPE_NAME, 45, 45},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 475, 475},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
microstrain_inertial_msgs__msg__MipGpsTimestamp__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *microstrain_inertial_msgs__msg__MipGpsTimestamp__get_individual_type_description_source(NULL),
    sources[1] = *microstrain_inertial_msgs__msg__MipGpsTimestampValidFlags__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
